<?php

/******************************** copyright ************************************
/*
/*	All upphovsrtt tillfaller adversus art, web & media samt 
/*	Victor Spng Arthursson.
/*
/*	Ingen kod fr anvndas i annat sammanhang n vad som skriftligen verrens-
/*	kommet med ovan nmnda, och inte heller modifieras p ngot stt. I vrigt
/*	gller svensk upphovsrttslagstiftning.
/*
/*	Fr ytterligare information och kontakt:
/*	web:	http://www.adversus.se
/*	mail:	info@adversus.se
/*	tel: +46 (0)733 20 40 02
/*
/*
/*						*** copyright - english version ***
/*
/*	All copyright belongs to adversus art, web & media and
/*	Victor Spng Arthursson.
/*
/*	No code may be used in other circumstances than what has been writtenly agreed
/*	upon with the copyright holder according to above, and it may not be modified
/*	in any what so ever way. For other issues, the swedish copyright laws applies.
/*
/*	More information and contact:
/*	web:	http://www.adversus.se
/*	mail:	info@adversus.se
/*	tel: +46 (0)733 20 40 02
/*
/******************************************************************************/


// *** Sprkvariabler ***

//$commentHandlerBasic_txt["SE"][0] = "";

// ### Sprkvariabser ###


// inkludera parent-klassen
include_once($prefs["base_path"] . "/classes/commentHandler.php");


class commentHandlerBasic extends commentHandler {

//	private $text;
	private $query;		// hller xpath-frgan
	private $origpath;	// sparar fregende stig
	
	function __construct($path = NULL) {
		// kalla frst konstruktorn i parentobjektet
		parent::__construct($path);
	}

	// den hr metoden rknar ut nya xpath:ar
	private function calculateXpath($path) {

		// om inte en ny stig har snts in, gr inget
		if($this->origpath!=$path) {	// ny path submittad, s rkna ut ny xpath
			// nollstll xpath-queryn
			$this->query = '//picturedata';
			
			// lgg till foldern
			$this->query .= '/folder[@origin="' . $path . '"]';
		}
		return true; // inget har ndrats s rkna inte ut ny xpath
	}
	
	public function getCommentData($path, $type = NULL) {
	
		// rkna ut xPath-query
		$this->calculateXpath($path);
	
		return parent::getCommentData($this->query, $type);
	}

	public function setCommentData($data, $folder, $type) {
		// om godknd typ
		if(in_array($type, $this->commentDataTypes)) {
			// stt frst stigen
			$this->calculateXpath($folder);
	
			// kr frgan fr att testa om elementet vi sker existerar eller inte

			$result = $this->xpath->query($this->query);

			// Ingen folder r inte bra...	
			if($result->length == 0)			
			{

				// hmta rootelementet
				$root = $this->xpath->query("//picturedata")->item(0);
				
				// skapa ett folder-element
				$element = $this->xml->createElement("folder");
				
				// lgg till origin
				$element->setAttribute("origin", $folder);

				// lgg till foldern till xml-rooten
				$parentElement = $root->appendChild($element);
				
				
			// stt parentfolder till denna
			}
			else {
				// ok - stigen existerade s stt bara vad som r parent
				$parentElement = $result->item(0);
			}
			// nsta frga r om elementet som ska innehlla datan existerar
			$result = $this->xpath->query($this->query . "/$type");
			// Inga element r inte bra...	
			if($result->length == 0) {
				// skapa elementet som vi vill stta
				$commentDataElement = $this->xml->createElement($type);
				// appenda det
				$parentElement->appendChild($commentDataElement);
			// annars < vi hittat det
			}
			else {
				$commentDataElement = $result->item(0);
			}
			// stt dess vrde
			$commentDataElement->nodeValue = utf8_encode($data);

			return true;
			
		}
		// inte godknd typ
		else
			return false;
	}
	
}