<?php

/******************************** copyright ************************************
/*
/*	All upphovsrtt tillfaller adversus art, web & media samt 
/*	Victor Spng Arthursson.
/*
/*	Ingen kod fr anvndas i annat sammanhang n vad som skriftligen verrens-
/*	kommet med ovan nmnda, och inte heller modifieras p ngot stt. I vrigt
/*	gller svensk upphovsrttslagstiftning.
/*
/*	Fr ytterligare information och kontakt:
/*	web:	http://www.adversus.se
/*	mail:	info@adversus.se
/*	tel: +46 (0)733 20 40 02
/*
/*
/*						*** copyright - english version ***
/*
/*	All copyright belongs to adversus art, web & media and
/*	Victor Spng Arthursson.
/*
/*	No code may be used in other circumstances than what has been writtenly agreed
/*	upon with the copyright holder according to above, and it may not be modified
/*	in any what so ever way. For other issues, the swedish copyright laws applies.
/*
/*	More information and contact:
/*	web:	http://www.adversus.se
/*	mail:	info@adversus.se
/*	tel: +46 (0)733 20 40 02
/*
/******************************************************************************/

// *** sprkvariabler ***

$showimage_txt["SE"][0] = "Det var problem med att spara om bilden engligt instllningen speed-resize. Med all sannolikhet saknar PHP skriv-rttigheter i den aktuella bildmappen i huvudbildmappen. Fr att se bilder, kryssa antingen ur rutan speedresize, eller ge systemet skrivrttigheter i den aktuella foldern";
$showimage_txt["UK"][0] = "There was a problem re-saving the picture using the speed-resize-feature. Probably PHP doesn't have write-permissions in the active picture-folder in the main picture-folder. To be able to see pictures, either un-check speedresize, or grant the system write-permissions in the corresponding folder";
$showimage_txt["SE"][1] = "och eventuellt bilden";
$showimage_txt["UK"][1] = "and likely also to the image";

// ### sprkvariabler ###

include ("classes/imageProcessor.php");
include_once("functions/function_parse_ini_file_substitute.php");

// ls in instllningarna
if(!$prefs = @parse_ini_file("preferences/settings1.php"))
	$prefs = parse_ini_file_substitute("preferences/settings1.php");

// stt kvalitet
$quality = 	(isset($_GET["quality"]) && $_GET["quality"]=="high"?"high":"low");

// stt filnamn
$filename = /* $prefs["base_path"] . "/" . $prefs["pic_path"] . "/" . */$_GET["imagepath"];


// dags fr ett objekt
if(!($imageObj = new imageProcessor($filename))) // bilden stts vid load och laddas drfr som den ska
	die("Kunde inte initiera ett imageProcessor-objekt.");
	
// ska det skalas om och ngon av bildens sidor r lngre n 150% av vald storlek samt lngre n den andra
if(isset($prefs["speedresize"]) && $prefs["speedresize"] && ($imageObj->src_width > $prefs["big_size"]*1.5 or $imageObj->src_height > $prefs["big_size"]*1.5)) {
	if(!$imageObj->setSize(false,true)) // stter storlekar (rknar ut de nya) - false i funktionsanropet anger att det r en stor bild som ska returneras 
		die($imageObj->lastError);
	if(!$imageObj->optimizeImage(NULL, $filename)) // sparar om bilden 
		die($imageObj->lastError);
}
## ska det skalas om?
if(!$imageObj->setSize((isset($_GET["thumb"])?$_GET["thumb"]:false))) // stter storlekar (rknar ut de nya) - false i funktionsanropet anger att det r en stor bild som ska returneras 
	die($imageObj->lastError);
if(!$imageObj->returnHeader()) // stter header. Eftersom den lmnas tom stts header till originalbildens typ
	die($imageObj->lastError);
if(!$imageObj->optimizeImage()) // returnerar strmmen frn en optimerad bild. 
	die($imageObj->lastError);
?>